searchNodes=[{"ref":"NervesHubLink.html","title":"NervesHubLink","type":"module","doc":""},{"ref":"NervesHubLink.html#connected?/0","title":"NervesHubLink.connected?/0","type":"function","doc":"Checks if the device is connected to the NervesHub channel."},{"ref":"NervesHubLink.html#socket_connected?/1","title":"NervesHubLink.socket_connected?/1","type":"function","doc":"Checks if the device has a socket connection with NervesHub"},{"ref":"NervesHubLink.html#status/0","title":"NervesHubLink.status/0","type":"function","doc":"Current status of the device channel"},{"ref":"NervesHubLink.Application.html","title":"NervesHubLink.Application","type":"module","doc":""},{"ref":"NervesHubLink.Application.html#start/2","title":"NervesHubLink.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"NervesHubLink.Certificate.html","title":"NervesHubLink.Certificate","type":"module","doc":""},{"ref":"NervesHubLink.Certificate.html#ca_certs/0","title":"NervesHubLink.Certificate.ca_certs/0","type":"function","doc":""},{"ref":"NervesHubLink.Certificate.html#fwup_public_keys/0","title":"NervesHubLink.Certificate.fwup_public_keys/0","type":"function","doc":""},{"ref":"NervesHubLink.Certificate.html#key_pem_to_der/1","title":"NervesHubLink.Certificate.key_pem_to_der/1","type":"function","doc":""},{"ref":"NervesHubLink.Certificate.html#pem_to_der/1","title":"NervesHubLink.Certificate.pem_to_der/1","type":"function","doc":""},{"ref":"NervesHubLink.Certificate.html#public_keys/0","title":"NervesHubLink.Certificate.public_keys/0","type":"function","doc":""},{"ref":"NervesHubLink.Channel.html","title":"NervesHubLink.Channel","type":"module","doc":""},{"ref":"NervesHubLink.Channel.html#child_spec/1","title":"NervesHubLink.Channel.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"NervesHubLink.Channel.html#init/1","title":"NervesHubLink.Channel.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"NervesHubLink.Channel.html#start_link/1","title":"NervesHubLink.Channel.start_link/1","type":"function","doc":""},{"ref":"NervesHubLink.Channel.State.html","title":"NervesHubLink.Channel.State","type":"module","doc":""},{"ref":"NervesHubLink.Channel.State.html#t:status/0","title":"NervesHubLink.Channel.State.status/0","type":"type","doc":""},{"ref":"NervesHubLink.Channel.State.html#t:t/0","title":"NervesHubLink.Channel.State.t/0","type":"type","doc":""},{"ref":"NervesHubLink.Client.html","title":"NervesHubLink.Client","type":"behaviour","doc":"A behaviour module for customizing if and when firmware updates get applied. By default NervesHubLink applies updates as soon as it knows about them from the NervesHubLink server and doesn&#39;t give warning before rebooting. This let&#39;s devices hook into the decision making process and monitor the update&#39;s progress. Example defmodule MyApp.NervesHubLinkClient do @behaviour NervesHubLink.Client # May return: # * `:apply` - apply the action immediately # * `:ignore` - don&#39;t apply the action, don&#39;t ask again. # * `{:reschedule, timeout_in_milliseconds}` - call this function again later. @impl NervesHubLink.Client def update_available(data) do if SomeInternalAPI.is_now_a_good_time_to_update?(data) do :apply else {:reschedule, 60_000} end end end To have NervesHubLink invoke it, add the following to your config.exs: config :nerves_hub, client: MyApp.NervesHubLinkClient"},{"ref":"NervesHubLink.Client.html#c:handle_error/1","title":"NervesHubLink.Client.handle_error/1","type":"callback","doc":"Called when downloading a firmware update fails. The return value of this function is not checked."},{"ref":"NervesHubLink.Client.html#handle_error/2","title":"NervesHubLink.Client.handle_error/2","type":"function","doc":"This function is called internally by NervesHubLink to notify clients of fwup errors."},{"ref":"NervesHubLink.Client.html#c:handle_fwup_message/1","title":"NervesHubLink.Client.handle_fwup_message/1","type":"callback","doc":"Called on firmware update reports. The return value of this function is not checked."},{"ref":"NervesHubLink.Client.html#handle_fwup_message/2","title":"NervesHubLink.Client.handle_fwup_message/2","type":"function","doc":"This function is called internally by NervesHubLink to notify clients of fwup progress."},{"ref":"NervesHubLink.Client.html#c:update_available/1","title":"NervesHubLink.Client.update_available/1","type":"callback","doc":"Called to find out what to do when a firmware update is available. May return one of: apply - Download and apply the update right now. ignore - Don&#39;t download and apply this update. {:reschedule, timeout} - Defer making a decision. Call this function again in timeout milliseconds."},{"ref":"NervesHubLink.Client.html#update_available/2","title":"NervesHubLink.Client.update_available/2","type":"function","doc":"This function is called internally by NervesHubLink to notify clients."},{"ref":"NervesHubLink.Client.html#t:fwup_message/0","title":"NervesHubLink.Client.fwup_message/0","type":"type","doc":"Firmware update progress, completion or error report"},{"ref":"NervesHubLink.Client.html#t:update_data/0","title":"NervesHubLink.Client.update_data/0","type":"type","doc":"Update that comes over a socket."},{"ref":"NervesHubLink.Client.html#t:update_response/0","title":"NervesHubLink.Client.update_response/0","type":"type","doc":"Supported responses from update_available/1"},{"ref":"NervesHubLink.Client.Default.html","title":"NervesHubLink.Client.Default","type":"module","doc":"Default NervesHubLink.Client implementation This client always accepts an update."},{"ref":"NervesHubLink.Configurator.html","title":"NervesHubLink.Configurator","type":"behaviour","doc":""},{"ref":"NervesHubLink.Configurator.html#build/0","title":"NervesHubLink.Configurator.build/0","type":"function","doc":""},{"ref":"NervesHubLink.Configurator.html#c:build/1","title":"NervesHubLink.Configurator.build/1","type":"callback","doc":""},{"ref":"NervesHubLink.Configurator.Config.html","title":"NervesHubLink.Configurator.Config","type":"module","doc":""},{"ref":"NervesHubLink.Configurator.Default.html","title":"NervesHubLink.Configurator.Default","type":"module","doc":""},{"ref":"NervesHubLink.Configurator.NervesKey.html","title":"NervesHubLink.Configurator.NervesKey","type":"module","doc":""},{"ref":"NervesHubLink.Connection.html","title":"NervesHubLink.Connection","type":"module","doc":"Agent used to keep the simple state of the devices connection to nerves-hub.org. The state is a tuple where the first element is an atom of :connected or :disconnected and the second element is the value of System.monotonic_time/1 at the time of setting the new state. In practice, this state is set anytime the device connection to nerves-hub.org channel changes. Likewise, it is set after a HTTP request fails or succeeds. This makes it useful when you want to consider the connection to nerves-hub.org as part of the overall health of the device and perform explicit actions based on the result, such as using the Erlang :heart module to force a reboot if the callback check fails. # Set a callback for heart to check every 5 seconds. If the function returns anything other than # `:ok`, it will cause reboot. :heart.set_callback(NervesHubLink.Connection, :check!) Or, you can use the check as part of a separate function with other health checks as well defmodule MyApp.Checker do def health_check do with :ok &lt;- NervesHubLink.Connection.check, :ok &lt;- MyApp.another_check, :ok &lt;- MyApp.yet_another_check, do :ok else err -&gt; err end end end # Somewhere else in MyApp :heart.set_callback(MyApp.Checker, :health_check)"},{"ref":"NervesHubLink.Connection.html#check/0","title":"NervesHubLink.Connection.check/0","type":"function","doc":"A simple check to see if the device is considered ok. This will still return :ok if the device is in a disconnected state, but within the :connection_timeout timeframe to allow for intermittent connection failures that are recoverable. Once the disconnection has exceeded the timeout, this check will be consided unhealthy. The default connection timeout is 15 minutes (900 seconds), but is configurable: # 60 second timeout config :nerves_hub, connection_timeout: 60"},{"ref":"NervesHubLink.Connection.html#check!/0","title":"NervesHubLink.Connection.check!/0","type":"function","doc":"Same as check/0, but raises RuntimeError if the check fails"},{"ref":"NervesHubLink.Connection.html#child_spec/1","title":"NervesHubLink.Connection.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"NervesHubLink.Connection.html#connected/0","title":"NervesHubLink.Connection.connected/0","type":"function","doc":"Sets the state to {:connected, System.monotonic_time(:seconds)}"},{"ref":"NervesHubLink.Connection.html#disconnected/0","title":"NervesHubLink.Connection.disconnected/0","type":"function","doc":"Sets the state to {:disconnected, System.monotonic_time(:seconds)}"},{"ref":"NervesHubLink.Connection.html#read/0","title":"NervesHubLink.Connection.read/0","type":"function","doc":"Reads the state directly without modification."},{"ref":"NervesHubLink.Connection.html#start_link/1","title":"NervesHubLink.Connection.start_link/1","type":"function","doc":""},{"ref":"NervesHubLink.ConsoleChannel.html","title":"NervesHubLink.ConsoleChannel","type":"module","doc":"Wraps IEx.Server setting this process as the group_leader. This allows tunneling the io_request&#39;s over the channel socket. The remote console ability is disabled by default and requires the remote_iex key to be enabled in the config: config :nerves_hub_link, remote_iex: true Once connected, IO requests on the device will be pushed up the socket for the following events: get_line - IO is requesting the next line from user input. Typically just iex () &gt; put_chars - Display the sepcified characters from the IEx Server for user review This requires an immediate reply of :ok and then IEx will send a :get_line request to await the user input. NervesHubLinkWeb handles immediately replies :ok to these events (see below) init_attempt - Pushed asynchronously after attempting to init an IEx Server. Payload has a success key with a boolean value to specify whether the server process was started successfully or not The following events are supported from the socket: iex_terminate - Kill any running IEx server in the channel init - The console channel starts without a linked IEx Server by default. This must be called before sending I/O back and forth. Only one IEx Server is initialized for this channel. If IEx Server has already been initialized and is in a good state, then calling init will continue to use the linked session and have no effect. io_reply - Send the reply characters to the IO. Requires specific keys in payload kind - event that you&#39;re replying to. Either get_line or put_chars data - characters to be put into the IO. put_chars requires this to be ok or error phx_close or phx_error - This will cause the channel to attempt rejoining every 5 seconds. You can change the rejoin timing in the config config :nerves_hub_link, rejoin_after: 3_000 For more info, see The Erlang I/O Protocol"},{"ref":"NervesHubLink.ConsoleChannel.html#child_spec/1","title":"NervesHubLink.ConsoleChannel.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"NervesHubLink.ConsoleChannel.html#init/1","title":"NervesHubLink.ConsoleChannel.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"NervesHubLink.ConsoleChannel.html#start_link/1","title":"NervesHubLink.ConsoleChannel.start_link/1","type":"function","doc":""},{"ref":"NervesHubLink.ConsoleChannel.State.html","title":"NervesHubLink.ConsoleChannel.State","type":"module","doc":""},{"ref":"NervesHubLink.HTTPFwupStream.html","title":"NervesHubLink.HTTPFwupStream","type":"module","doc":"Download and install a firmware update."},{"ref":"NervesHubLink.HTTPFwupStream.html#child_spec/1","title":"NervesHubLink.HTTPFwupStream.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"NervesHubLink.HTTPFwupStream.html#get/2","title":"NervesHubLink.HTTPFwupStream.get/2","type":"function","doc":"Download and install the firmware at the specified URL"},{"ref":"NervesHubLink.HTTPFwupStream.html#get_header/2","title":"NervesHubLink.HTTPFwupStream.get_header/2","type":"function","doc":""},{"ref":"NervesHubLink.HTTPFwupStream.html#start/1","title":"NervesHubLink.HTTPFwupStream.start/1","type":"function","doc":""},{"ref":"NervesHubLink.HTTPFwupStream.html#start_link/1","title":"NervesHubLink.HTTPFwupStream.start_link/1","type":"function","doc":"Start the downloader process A callback process should be passed Messages will be received in the shape: {:fwup_message, message} - see the docs for Fwup for more info. {:http_error, {status_code, body}} {:http_error, :timeout} {:http_error, :too_many_redirects}"},{"ref":"NervesHubLink.HTTPFwupStream.html#stop/1","title":"NervesHubLink.HTTPFwupStream.stop/1","type":"function","doc":"Stop the downloader"},{"ref":"readme.html","title":"NervesHubLink","type":"extras","doc":"NervesHubLink This is the official client for devices that want to receive firmware updates from NervesHub."},{"ref":"readme.html#overview","title":"NervesHubLink - Overview","type":"extras","doc":"NervesHub is an open-source firmware update server that works well with Nerves-based devices. A managed version is available at nerves-hub.org and it&#39;s possible to host your own. NervesHub provides many of the features that you&#39;d expect in a firmware update server. Fundamentally, devices connect to the server by joining a long-lived Phoenix channel (for HTTP polling, see nerves_hub_link_http). If a firmware update is available, NervesHub will provide a URL to the device and the device can update immediately or when convenient. NervesHub does impose some requirements on devices and firmware that may require changes to your Nerves projects: Firmware images are cryptographically signed (both NervesHub and devices validate signatures) Devices are identified by a unique serial number Each device has its own SSL certificate for authentication with NervesHub These changes enable NervesHub to provide assurances that the firmware bits you intend to install on a set of devices make it to those devices unaltered."},{"ref":"readme.html#getting-started","title":"NervesHubLink - Getting Started","type":"extras","doc":"The following sections will walk you through updating your Nerves project to work with the nerves-hub.org NervesHub server. Using your own NervesHub server will require setting URLs to point elsewhere and is not covered below to simplify first usage. Many of the steps below may feel manual, but they can and are automated by NervesHub users to set up automatic firmware updates from CI and to manufacture large numbers of devices. Creating an account on nerves-hub.org The nerves-hub.org NervesHub server is currently in limited beta so it does not allow new users to sign up. However, you found these docs and if you can use mix and endure some API changes, you can join us. In addition to the web site, NervesHub provides a command line interface (CLI). Some features are only available via the CLI. To enable the CLI in your project, add nerves_hub_cli to your dependency list: defp deps do [ {:nerves, &quot;~&gt; 1.3&quot;, runtime: false}, {:nerves_hub_cli, &quot;~&gt; 0.1&quot;, runtime: false} ... ] ++ deps(@target) end Run mix deps.get to download the nerves_hub_cli dependency. Presumably you do not have an account yet. Create one by running: mix nerves_hub.user register If you already have an account, make sure that you have authenticated by running: mix nerves_hub.user auth Adding NervesHubLink to your project The first step is to add nerves_hub_link to your target dependencies in your project&#39;s mix.exs. Since NervesHub uses SSL certificates, the time must be set on the device or certificate validity checks will fail. If you&#39;re not already setting the time, add nerves_time to your dependencies. For example: defp deps(target) do [ {:nerves_runtime, &quot;~&gt; 0.9&quot;}, {:nerves_hub_link, &quot;~&gt; 0.1&quot;}, {:nerves_time, &quot;~&gt; 0.2&quot;}, ... ] ++ system(target) end Next, update your config.exs so that the nerves_hub_link library can help provision devices. Do this by adding provisioning: :nerves_hub_link to the :nerves, :firmware option like this: config :nerves, :firmware, provisioning: :nerves_hub_link The library won&#39;t connect to nerves-hub.org unless requested and SSL options must be configured. If using NervesKey, you can tell NervesHubLink to read those certificates and key from the chip and assign the SSL options for you by enabling add it as a dependency: def deps() do [ {:nerves_hub_link, &quot;~&gt; 0.7&quot;}, {:nerves_key, &quot;~&gt; 0.5&quot;} ] end NervesKey will default to using i2c bus 1 and :primary cerificate pair. However, you can cusomtize these options as well to use a different bus and certificate pair: config :nerves_hub_link, :nerves_key, certificate_pair: :aux, i2c_bus: 0 If you aren&#39;t using NervesKey, you can also provide your own options to use for the NervesHub socket connection via the :socket and :ssl keys, which are forwarded on to phoenix_client when creating the socket connection (see PhoenixClient.Socket module for support options. Any valid Erlang ssl socket option can go in the :ssl key. config :nerves_hub_link, socket: [ json_library: Jason, heartbeat_interval: 45_000 ], ssl: [ cert: &quot;some_cert_der&quot;, keyfile: &quot;path/to/keyfile&quot; ] Runtime Configuration Some cases require that connection configuration happens at runtime like selectively choosing which cert/key to use based on device, or reading a file stored on device which isn&#39;t available during compilation. Whatever the reason, NervesHubLink also supports runtime configuration via the NervesHubLink.Configurator behavior. This is called during application startup to build the configuration that is to be used for the connection. When implementing the behavior, you&#39;ll receive the initial default config read in from the application environment and you can modify it however you need. For example: defmodule MyApp.Configurator do @behaviour NervesHubLink.Configurator @impl true def build(config) do ssl = [certfile: &quot;/root/ssl/cert.pem&quot;, keyfile: &quot;/root/ssl/key.pem&quot;] %{config | ssl: ssl} end end Then you specify which configurator NervesHubLink should use in config.exs: config :nerves_hub_link, configurator: MyApp.Configurator Creating a NervesHub product A NervesHub product groups devices that run the same kind of firmware. All devices and firmware images have a product. NervesHub provides finer grain mechanisms for grouping devices, but a product is needed to get started. By default, NervesHub uses the :app name in your mix.exs for the product name. If you would like it to use a different name, add a :name field to your Mix.Project.config(). For example, NervesHub would use &quot;My Example&quot; instead of &quot;example&quot; for the following project: def project do [ app: :example, name: &quot;My Example&quot; ] end For the remainder of this document, though, we will not use the :name field and simply use the product name example. Create a new product on NervesHub by running: mix nerves_hub.product create Creating NervesHub firmware signing keys NervesHub requires cryptographic signatures on all managed firmware. Devices receiving firmware from NervesHub validate signatures. Since firmware is signed before uploading to NervesHub, NervesHub or any service NervesHub uses cannot modify it. Firmware authentication uses Ed25519 digital signatures. You need to create at least one public/private key pair and copy the public key part to NervesHub and to devices. NervesHub tooling helps with both. A typical setup has multiple signing keys to support key rotation and &quot;development&quot; keys that are not as protected. Start by creating a devkey firmware signing key pair: mix nerves_hub.key create devkey On success, you&#39;ll see the public key. You can confirm using the NervesHub web interface that the public key exists. Private keys are never sent to the NervesHub server. NervesHub requires valid signatures from known keys on all firmware it distributes. The next step is to make sure that the public key is embedded into the firmware image. This is important. The device uses this key to verify the firmware it receives from a NervesHub server before applying the update. This protects the device against anyone tampering with the firmware image between when it was signed by you and when it is installed. All firmware signing public keys need to be added to your config.exs. Keys that are stored locally (like the one we just created) can be referred to by their atom name: config :nerves_hub_link, fwup_public_keys: [:devkey] If you have keys that cannot be stored locally, you will have to copy/paste their public key: config :nerves_hub_link, fwup_public_keys: [ # devkey &quot;bM/O9+ykZhCWx8uZVgx0sU3f0JJX7mqnAVU9VGeuHr4=&quot; ] The nerves_hub_link dependency converts key names to public keys at compile time. If you haven&#39;t compiled your project yet, run mix firmware now. If you have compiled it, mix won&#39;t know to recompile nerves_hub_link due to the configuration change. Force it to recompile by running: mix deps.compile nerves_hub_link --force mix firmware While not shown here, you can export keys for safe storage. Additionally, key creation and firmware signing can be done outside of the mix tooling. The only part that is required is that the firmware signing public keys be added to your config.exs and to the NervesHub server. Publishing firmware Uploading firmware to NervesHub is called publishing. To publish firmware start by calling: mix firmware Firmware can only be published if has been signed. You can sign the firmware by running. mix nerves_hub.firmware sign --key devkey Firmware can also be signed while publishing: mix nerves_hub.firmware publish --key devkey Initializing devices In this example we will create a device with a hardware identifier 1234. The device will also be tagged with qa so we can target it in our deployment group. We will select y when asked if we would like to generate device certificates. Device certificates are required for a device to establish a connection with the NervesHub server. However, if you are using NervesKey, you can select n to skip generating device certificates. $ mix nerves_hub.device create NervesHub organization: nerveshub identifier: 1234 description: test-1234 tags: qa Local user password: Device 1234 created Would you like to generate certificates? [Yn] y Creating certificate for 1234 Finished It is important to note that device certificate private keys are generated and stay on your host computer. A certificate signing request is sent to the server, and a signed public key is passed back. Generated certificates will be placed in a folder titled nerves-hub in the current working directory. You can specify a different location by passing --path /path/to/certs to NervesHubCLI mix commands. NervesHub certificates and hardware identifiers are persisted to the firmware when the firmware is burned to the SD card. To make this process easier, you can call nerves_hub.device burn IDENTIFIER. In this example, we are going to burn the firmware and certificates for device 1234 that we created. mix nerves_hub.device burn 1234 Your device will now connect to NervesHub when it boots and establishes an network connection. Creating deployments Deployments associate firmware images to devices. NervesHub won&#39;t send firmware to a device until you create a deployment. First find the UUID of the firmware. You can list the firmware on NervesHub by calling: mix nerves_hub.firmware list Firmwares: ------------ product: example version: 0.3.0 platform: rpi3 architecture: arm uuid: 1cbecdbb-aa7d-5aee-4ba2-864d518417df In this example we will create a new deployment for our test group using firmware 1cbecdbb-aa7d-5aee-4ba2-864d518417df. mix nerves_hub.deployment create NervesHub organization: nerveshub Deployment name: qa_deployment firmware uuid: 1cbecdbb-aa7d-5aee-4ba2-864d518417df version condition: tags: qa Local user password: Deployment test created Here we create a new deployment called qa_deployment. In the conditions of this deployment we left the version condition unspecified and the tags set to only qa. This means that in order for a device to qualify for an update, it needs to have at least the tags [qa] and the device can be coming from any version. At this point we can try to update the connected device. Start by bumping the application version number from 0.1.0 to 0.1.1. Then, create new firmware: mix firmware We can publish, sign, and deploy firmware in a single command now. mix nerves_hub.firmware publish --key devkey --deploy qa_deployment Conditionally applying updates It&#39;s not always appropriate to apply a firmware update immediately. Custom logic can be added to the device by implementing the NervesHubLink.Client behaviour and telling the NervesHubLink OTP application about it. Here&#39;s an example implementation: defmodule MyApp.NervesHubLinkClient do @behaviour NervesHubLink.Client # May return: # * `:apply` - apply the action immediately # * `:ignore` - don&#39;t apply the action, don&#39;t ask again. # * `{:reschedule, timeout_in_milliseconds}` - call this function again later. @impl NervesHubLink.Client def update_available(data) do if SomeInternalAPI.is_now_a_good_time_to_update?(data) do :apply else {:reschedule, 60_000} end end end To have NervesHubLink invoke it, update your config.exs as follows: config :nerves_hub_link, client: MyApp.NervesHubLinkClient Enabling remote IEx access It&#39;s possible to remotely log into your device via the NervesHub web interface. This feature is disabled by default. To enable, add the following to your config.exs: config :nerves_hub_link, remote_iex: true You may also need additional permissions on NervesHub to see the device and to use the remote IEx feature."},{"ref":"readme.html#debugging-errors","title":"NervesHubLink - Debugging errors","type":"extras","doc":"TLS client errors If you see the following in your logs: 14:26:06.926 [info] [&#39;TLS&#39;, 32, &#39;client&#39;, 58, 32, 73, 110, 32, 115, 116, 97, 116, 101, 32, &#39;cipher&#39;, 32, &#39;received SERVER ALERT: Fatal - Unknown CA&#39;, 10] This probably indicates that the signing certificate hasn&#39;t been uploaded to nerves-hub.org so the device can&#39;t be authenticated. Double check that you ran: mix nerves_hub.ca_certificate register my-signer.cert Another possibility is that the device wasn&#39;t provisioned with the certificate that&#39;s on nerves-hub.org."}]